function displayUnitInfo(id) {
    var un = v.find(function (u) { return u.id === id });
    document.getElementById("avatar").innerHTML = `<div id="outerBorder" style="border-left-color:${un.secendColor}; border-top-color:${un.secendColor}; border-right-color:${un.firstColor}; border-bottom-color:${un.firstColor};"><img id="avatar" style="background-color: ${un.color}; border-left-color:${un.firstColor}; border-top-color:${un.firstColor}; border-right-color:${un.secendColor}; border-bottom-color:${un.secendColor};" src="${un.img}"></div><br><br><br>`;
   fun("name",un.name);
   fun("stack",un.stack);
   fun("accuracy", un.accuracy + "%");
   fun("AP", un.AP);
   fun("range",un.range);
}
function clickedCell(cell) {
    var column = parseInt(cell.id[1]);
    var row = parseInt(cell.id[3]);
    var oldX = v[0].x;
    var oldY = v[0].y;

    if (map[row][column] === 1) {
        clearCells(oldY, oldX);
        v[0].x = column;
        v[0].y = row;
        map[row][column] = v[0]
        makeMap();
        alloc(map);
        if (v[0].AP === 1) {
            v[0].AP = actualAp;
            sendToLog(`${v[0].name} from X: ${oldX}, Y: ${oldY} moving to X: ${column} Y: ${row}`, v[0].fontColor)
            uQ();
        } else {
            sendToLog(`${v[0].name} from X: ${oldX}, Y: ${oldY} moving to X: ${column} Y: ${row}`, v[0].fontColor)
            v[0].AP--;
            displayUnitInfo(v[0].id);
            showPaths(1, v[0].x, v[0].y, v[0].color);
        }
    } else if (map[row][column] !== 0 && v[0].id !== map[row][column].id && v[0].nation !== map[row][column].nation) {
        v[0].AP--;
        displayUnitInfo(v[0].id);
        var en = map[row][column];

        var aM = 0;

        if (terreinMap[en.y][en.x] === 1) {
            aM = -10;
        }
        if (terreinMap[en.y][en.x] === 4) {
            aM = -5;
        }
        if (terreinMap[en.y][en.x] === 6) {
            aM = -10;
        }
        if (terreinMap[en.y][en.x] === 7) {
            aM = -15;
        }
        var distance = calcDistance(v[0].x, v[0].y, en.x, en.y);
        var kU = at(v[0].accuracy, v[0].stack, distance, aM);
        en.stack = en.stack - kU;
        sendToLog(`${v[0].name} attacking: ${en.name} - ${kU} unit(s)`, v[0].fontColor)
        if (en.stack <= en.stack * 0.15) {
            sendToLog(`${en.name} fall into a panic`, v[0].fontColor)
            var kR = v.find(function (item) { return item.id === en.id });
            v.splice(v.indexOf(kR), 1);
            map[kR.y][kR.x] = 0;
            makeMap();
            alloc(map);
            clearCells(oldY, oldX);
            makeMap();
            alloc(map);
            uQ();
        } else {
            alloc(map);
        }
        if (v[0].AP === 0) {
            v[0].AP = actualAp;
            clearCells(oldY, oldX);
            makeMap();
            alloc(map);
            uQ();
        }
    }
}
function at(accuracy, stack, distance, mod) {
    var k = 0;
    var pR = 0;
    if (terreinMap[v[0].y][v[0].x] === 2) {
        pR += 2;
    }
    accuracy = accuracy + mod;
    for (var i = 0; i < stack; i++) {
        if (Math.floor(distance.toFixed(2)) - v[0].range + pR > 0) {
            if ((Math.floor(Math.random() * 100) + 1) <= accuracy - accuracy * ((((Math.floor(distance).toFixed(2)) - v[0].range + pR) * 30) / 100)) {
                k++;
            }
        }
        else {
            if (Math.floor(Math.random() * 100) + 1 < accuracy) {
                k++;
            }
        }

    }
    return k;
}
function calcDistance(x1, y1, x2, y2) {
    return Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
}
function uQ() {
    var eU = v.shift();
    v.push(eU);
    var q = '';
    v.forEach(function (u) {
        q += `<img class="min-avatar" style="background-color: ${u.color};" src="${u.img}">`;
    });
    document.getElementById("queue").innerHTML = q;
    displayUnitInfo(v[0].id);
    actualAp = v[0].AP;
    changeUnit();
}

function showPaths(mp, x, y, c) {
    p = 'pointer';
    c = "#80808065";
    for (var i = 1; i <= 1; i++) {

        if (x + i < 10 && map[y][x + i] === 0) {
            var c1 = document.getElementById(`x${x + i}y${y}`)
            c1.style.backgroundColor = c;
            c1.style.cursor = p;
            map[y][x + i] = 1;
        }

        if (y + i < 8 && map[y + i][x] === 0) {
            var c2 = document.getElementById(`x${x}y${y + i}`);
            c2.style.backgroundColor = c;
            c2.style.cursor = p;
            map[y + i][x] = 1;
        }

        if (x - i >= 0 && map[y][x - i] === 0) {
            var c3 = document.getElementById(`x${x - i}y${y}`);
            c3.style.backgroundColor = c;
            c3.style.cursor = p;
            map[y][x - i] = 1;
        }

        if (y - i >= 0 && map[y - i][x] === 0) {
            var c4 = document.getElementById(`x${x}y${y - i}`);
            c4.style.backgroundColor = c;
            c4.style.cursor = p;
            map[y - i][x] = 1;
        }

        if (x - i >= 0 && y - i >= 0 && map[y - i][x - i] === 0) {
            var c5 = document.getElementById(`x${x - i}y${y - i}`)
            c5.style.backgroundColor = c;
            c5.style.cursor = p;
            map[y - i][x - i] = 1;
        }

        if (x + i < 10 && y + i < 8 && map[y + i][x + i] === 0) {
            var c6 = document.getElementById(`x${x + i}y${y + i}`)
            c6.style.backgroundColor = c;
            c6.style.cursor = p;
            map[y + i][x + i] = 1;
        }

        if (y - i >= 0 && x + i < 10 && map[y - i][x + i] === 0) {
            var c7 = document.getElementById(`x${x + i}y${y - i}`)
            c7.style.backgroundColor = c;
            c7.style.cursor = p;
            map[y - i][x + i] = 1;
        }

        if (x - i >= 0 && y + i < 8 && map[y + i][x - i] === 0) {
            var c8 = document.getElementById(`x${x - i}y${y + i}`)
            c8.style.backgroundColor = c;
            c8.style.cursor = p;
            map[y + i][x - i] = 1;
        }
    }
}
function clearCells(y, x) {
    map[y][x] = 0;
    if (x + 1 < 10) {
        map[y][x + 1] = 0;
    }

    if (y + 1 < 8) {
        map[y + 1][x] = 0;
    }
    if (x - 1 >= 0) {
        map[y][x - 1] = 0;
    }
    if (y - 1 >= 0) {
        map[y - 1][x] = 0;
    }
    if (y - 1 >= 0 && x - 1 >= 0) { map[y - 1][x - 1] = 0; }
    if (x + 1 < 10 && y + 1 < 8) { map[y + 1][x + 1] = 0; }
    if (y + 1 < 8 && x - 1 >= 0) { map[y + 1][x - 1] = 0; }
    if (y - 1 >= 0 && x + 1 < 10) { map[y - 1][x + 1] = 0; }
}