var terreinMap = [
    [1, 8, 3, 0, 0, 2, 1, 1, 1, 1],
    [1, 1, 3, 8, 0, 2, 4, 1, 1, 1],
    [1, 1, 3, 3, 0, 0, 4, 4, 1, 1],
    [1, 1, 8, 3, 8, 0, 0, 0, 0, 2],
    [0, 0, 0, 3, 3, 7, 0, 0, 0, 7],
    [0, 0, 0, 5, 6, 0, 0, 0, 0, 5],
    [2, 5, 5, 7, 3, 4, 0, 0, 0, 1],
    [2, 5, 7, 7, 6, 4, 0, 2, 1, 1],
];
window.onload = makeMap;
function getT(y, x) {
    switch (terreinMap[y][x]) {
        case 0:
            return 'meadow'
        case 1:
            return 'forest'
        case 2:
            return 'hill'
        case 3:
            return 'river'
        case 4:
            return 'highGrass'
        case 5:
            return 'farmland'
        case 6:
            return 'bridge'
        case 7:
            return 'building'
        case 8:
            return 'swamp'
    }
    return 'meadow';
}


function makeMap() {
    var m = "";
    for (var y = 0; y < 8; y++) {
        for (var x = 0; x < 10; x++) {
            m = m + `<div  onmouseover="getTM(${y}, ${x})" onclick="clickedCell(this)" id="x` + x + 'y' + y + `"class="cell ${getT(y, x)}X"><div id="innerx${x}y${y}" class="terrain bgst ${getT(y, x)}"><div class="ttb"><span class="ttt">x:` + x + ' | y:' + y + '</span></div></div></div>';
        }
        m = m + '<div id="cls"></div>';
    }
    document.getElementById("map").innerHTML = m;
}
function infoOnClickLog(c, r) {
    var d = "| x:" + c + " | y:" + r + " |";
    sendToLog(d);
}
function getTM(y, x) {
    switch (terreinMap[y][x]) {
        case 0:
            fun("fieldMod", 'Meadow: none');
            break;
        case 1:
            fun("fieldMod", 'Forest: defence +10%');
            break;
        case 2:
            fun("fieldMod", 'Hill: range +2');
            break;
        case 3: fun("fieldMod", 'River: - 1AP');
            break;
        case 4: fun("fieldMod", 'High Grass: defence +5%');
            break;
        case 5: fun("fieldMod", 'Farmland: none');
            break;
        case 6: fun("fieldMod", 'Bridge: defence +10%');
            break;
        case 7: fun("fieldMod", 'Building: defence +15%');
            break;
        case 8: fun("fieldMod", 'Swamp: none');
            break;
        default:
            break;
    }
}